/*
 * =====================================================================================
 *
 *       Filename:  vcomm.c
 *
 *    Description:  Virtual Comm based on STR91x stack
 *
 *       Version:  1.0
 *       Created:  20 mar 2008 13:57:12
 *       Revision:  none
 *       Compiler:  gcc
 *       Licence: GPL v3
 *       Author:  Lucjan Bryndza <lucjan.bryndza@ep.com.pl>
 *       Company:  BoFF
 *
 * =====================================================================================
 */


#ifndef __VCOMM_H__
#define __VCOMM_H__


/*-----------------------------------------------------------*/

#define EOF (-1)


/*-----------------------------------------------------------*/
//Tx fifo size
#define VCOM_FIFO_TX_SIZE 256

//Rx fifo
#define VCOM_FIFO_RX_SIZE 256

/*-----------------------------------------------------------*/

int vcom_putchar(int c);

/*-----------------------------------------------------------*/
int vcom_getchar(void);

/*-----------------------------------------------------------*/
int vcom_rxbytes(void);

/*-----------------------------------------------------------*/

void vcom_flush(void);


/*-----------------------------------------------------------*/
void vcom_init(void);

/*-----------------------------------------------------------*/
#endif
