/*
    Str912 book example9 - Simple uart library without interrupts
    Copyright (C) 2007  Lucjan Bryndza <lucjan.bryndza@ep.com.pl>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __UART_H__
#define __UART_H__



#include <91x_map.h>
#include <91x_scu.h>
#include <91x_uart.h>
#include <stdint.h>

/*-------------------------------------------------------------*/
//Main system clock is default 96MHz
#ifndef MAIN_CLOCK
#define MAIN_CLOCK 96000000LLU
#endif

/*-------------------------------------------------------------*/

//Initialize UART
int uartInit(UART_TypeDef *uartBase,int baud);

/*-------------------------------------------------------------*/

//Write character to UART
void uartWriteByte(UART_TypeDef *uartBase,uint8_t byte);

/*-------------------------------------------------------------*/
#define UART_EMPTY -1

//Uart read byte
int uartReadByte(UART_TypeDef *uartBase);

/*-------------------------------------------------------------*/

//Zapisz lancuch do portu szeregowego 
void uartWriteString(UART_TypeDef *uartBase,const char *string);

/*-------------------------------------------------------------*/
		
#endif
