#ifndef __I2C_H__
#define __I2C_H__
/*----------------------------------------------------------------------*/
/*
    Str912 book example12a - I2C library
    Copyright (C) 2008  Lucjan Bryndza <lucjan.bryndza@ep.com.pl>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/*----------------------------------------------------------------------*/
#define I2CSTAT_IDLE 1          /* Kontroler I2c wolny */
#define I2CSTAT_TX   0x82       /* Kontroler I2c podczas nadawania */
#define I2CSTAT_RX   0x83       /* Kontroler I2c podczas odbioru   */
#define I2CSTAT_ERR 0x4         /* Kontroler I2c wystapil blad     */
#define I2CSTAT_BUSY 0x80       /* Bit kontroler I2c zajety        */

/*----------------------------------------------------------------------*/
//Inicjalizuje port I2c (podajesz priorytet vic)
void i2c_init(int prio);

/*----------------------------------------------------------------------*/
//Zapisuje sekwencje bajtow
int i2c_write_start(uint8_t addr,uint8_t *bytes,int size);

/*----------------------------------------------------------------------*/

//Odczytuje sekwencje bajtow
int i2c_read_start(uint8_t addr,uint8_t *bytes,int size);

/*----------------------------------------------------------------------*/
//Sprawdz biezacy stan
int i2c_poll(void);

/*----------------------------------------------------------------------*/
//Funkcja wywolywana z kontekstu przerwania na zakonczenie odczytu
void i2c_register_read_handler(void (*pfn_read_handler)(void));

/*----------------------------------------------------------------------*/
//Funkcja wywolywana z kontekstu przerwania na zakonczenie zapisu
void i2c_register_write_handler(void (*pfn_write_handler)(void));

/*----------------------------------------------------------------------*/


#endif
