/*
    EEPROM emulation library
    Copyright (C) 2007  Lucjan Bryndza <lucjan.bryndza@ep.com.pl>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/*-----------------------------------------------------------------------*/
//Maximum aviable virtual address
#define EEPROM_MAX_VA ((8192-4)/4)
//Maximum avilable physical addr
#define EEPROM_MAX_PA (8192)

/*-----------------------------------------------------------------------*/
#define EEPROMERR_ADDR (-1)    /* Data at specified adress not found */
#define EEPROMERR_INIT (-3)  /* Data flash controler timeout */
#define EEPROMERR_TIMEOUT (-2)  /* Data flash controler timeout */
#define EEPROMERR_NOSPACE (-3)  /* Data flash controler timeout */
/*-----------------------------------------------------------------------*/

//Read eeprom data at specified address
int eepromflaRead(uint16_t addr);

/*-----------------------------------------------------------------------*/

//Write flash at specified virtual address
int eepromflaWrite(uint16_t addr,uint16_t data);

/*-----------------------------------------------------------------------*/

//Initialize eeprom procedure
int eepromflaInit();

/*-----------------------------------------------------------------------*/

