/* Ksiazka STR912 - Klasa portu IO
 * Lucjan Bryndza (c) 2007 - Licence: GPL v3. */

#include "gpio.h"

//Konstruktor klasy konfigurujacy wybrany port w kierunku wejsca lub wyjscia
gpioPort::gpioPort(ioPort port,uint8_t outp,uint8_t oc)
{
    volatile uint32_t *ddr=0;    
    //W zaleznosci od wybranego portu wlacz okreslony sygnal zegarowy
    switch(port)
    {
        case Gpio0:
            SCU->PRR1 |= __GPIO0;
            SCU->PCGR1 |= __GPIO0;
            ddr = &GPIO0->DDR;
            ioDr = GPIO0->DR;
            break;
        case Gpio1:
            SCU->PRR1 |= __GPIO1;
            SCU->PCGR1 |= __GPIO1;
            ddr =& GPIO1->DDR;
            ioDr = GPIO1->DR;
            break;
        case Gpio2:
            SCU->PRR1 |= __GPIO2;
            SCU->PCGR1 |= __GPIO2;
            ddr = &GPIO2->DDR;
            ioDr = GPIO2->DR;
            break;
        case Gpio3:
            SCU->PRR1 |= __GPIO3;
            SCU->PCGR1 |= __GPIO3;
            ddr = &GPIO3->DDR;
            ioDr = GPIO3->DR;
            break;
        case Gpio4:
            SCU->PRR1 |= __GPIO4;
            SCU->PCGR1 |= __GPIO4;
            ddr = &GPIO4->DDR;
            ioDr = GPIO4->DR;
            break;
        case Gpio5:
            SCU->PRR1 |= __GPIO5;
            SCU->PCGR1 |= __GPIO5;
            ddr = &GPIO5->DDR;
            ioDr = GPIO5->DR;
            break;
        case Gpio6:
            SCU->PRR1 |= __GPIO6;
            SCU->PCGR1 |= __GPIO6;
            ddr = &GPIO6->DDR;
            ioDr = GPIO6->DR;
            break;
    case Gpio7:
            SCU->PRR1 |= __GPIO7;
            SCU->PCGR1 |= __GPIO7;
            ddr = &GPIO7->DDR;
            ioDr = GPIO7->DR;
            break;
        case Gpio8:
            SCU->PRR1 |= __GPIO8;
            SCU->PCGR1 |= __GPIO8;
            ddr = &GPIO8->DDR;
            ioDr = GPIO8->DR;
            break;
        case Gpio9:
            SCU->PRR1 |= __GPIO9;
            SCU->PCGR1 |= __GPIO9;
            ddr = &GPIO9->DDR;
            ioDr = GPIO9->DR;
            break;
    }
    //Typ interfejsu OC lub PushPull
    SCU->GPIOTYPE[port] = oc;
    //Konfiguracja
    uint16_t iocfg=0;
    //Ustawienie odpowiednich portow w kierunku ew/wy
    for(int i=0;i<8;i++)
        if(outp & (1<<i) ) iocfg |= 0x1<<(2*i);
    //Kierunek portu
    SCU->GPIOOUT[port] = iocfg;
    //Wejscie alternatywne wylaczone
    SCU->GPIOIN[port] = 0x0;
    //Konfiguruj data register (kierunek)
    *ddr = outp;
}


