/* Ksiazka STR912 - Klasa portu IO
 * Lucjan Bryndza (c) 2007 - Licence: GPL v3. */

#ifndef __GPIO_H__
#define __GPIO_H__

#include "91x_map.h"
#include "91x_scu.h"
#include <stdint.h>


//Klasa obslugi portu GPIO
class gpioPort
{
    public:
        //Port number enum
        enum ioPort {Gpio0,Gpio1,Gpio2,Gpio3,Gpio4,Gpio5,Gpio6,Gpio7,Gpio8,Gpio9};
        //Konstruktor klasy
        gpioPort(ioPort port,uint8_t outp=0x0,uint8_t oc=0);
        //Odczyt i zapis zawartosci portu
        uint8_t readIo(uint8_t mask=0xff) { return ioDr[mask<<2]; }
        void writeIo(uint8_t data,uint8_t mask=0xff) { ioDr[mask<<2] = data; }
    private:
        volatile uint8_t *ioDr;
};

#endif

